Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPACState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPACState.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPACState.java	(revision 24)
@@ -17,7 +17,6 @@
 import geniusweb.progress.Progress;
 import geniusweb.progress.ProgressRounds;
+import geniusweb.protocol.NegoProtocol;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
 import geniusweb.protocol.session.SessionResult;
 import geniusweb.protocol.session.SessionState;
@@ -27,12 +26,25 @@
 import geniusweb.protocol.session.saop.SAOPSettings;
 import geniusweb.references.PartyWithProfile;
-import geniusweb.voting.VotingEvaluator;
-
+
+/**
+ * Keeps track of the current {@link Phase}. Adds initializing stuff and
+ * time/deadline checking. This state does not contain connections, this assumes
+ * that someone else handles (i.e. {@link NegoProtocol} that and the connections
+ * with the parties and that negotiation events are just pumped in from there.
+ * <p>
+ * This object is a bit tricky. It has two states
+ * <ol>
+ * <li>The initial state, where phase=null and connections are being made to all
+ * parties. At this point, problems can not be handled nicely yet because there
+ * are no PartyId's for problematic parties
+ * <li>The working state, where all parties are connected and all problems can
+ * be connected to an offending party.
+ * </ol>
+ */
 public class MOPACState implements SessionState {
 
-	private final Phase phase;
+	private final Phase phase; // maybe null while initializing
 	private final MOPACSettings settings;
 	private final Map<PartyId, PartyWithProfile> partyprofiles;
-	private final ProtocolToPartyConnections connections;
 	private final List<Action> actions;
 	private final Progress progress;
@@ -44,7 +56,5 @@
 	 */
 	public MOPACState(MOPACSettings settings) {
-		this(null, Arrays.asList(),
-				new ProtocolToPartyConnections(Collections.emptyList()), null,
-				settings, Collections.emptyMap());
+		this(null, Arrays.asList(), null, settings, Collections.emptyMap());
 
 	}
@@ -54,28 +64,26 @@
 	 *                      set something only after we have connections.
 	 * @param actions       the legal actions that have been done in the
-	 *                      negotiation. A new-sub-list is added for each phase
-	 *                      change. It is assumed that the last element of the
-	 *                      list is the list with actions taken in the current
-	 *                      phase. first action in first list is the oldest.
-	 *                      This MUST NOT contain illegal actions. Parties doing
-	 *                      illegal actions are killed and the offending action
-	 *                      ends up in the stacktrace. Previous actions of
-	 *                      crashed parties remain standing and valid.
-	 * @param conns         the existing party connections. we assume ownership
-	 *                      of this so it should not be modified although
-	 *                      connections may of course break.
+	 *                      negotiation. {@link PartyStates#getActions()} is
+	 *                      called to collect the actions after the phase is
+	 *                      finished.first action in list is the oldest. This
+	 *                      will not contain actions that immediately led to an
+	 *                      agreement, because {@link PartyStates} removes the
+	 *                      actions that led to an agreement. This MUST NOT
+	 *                      contain illegal actions. Parties doing illegal
+	 *                      actions are killed and the offending action ends up
+	 *                      in the stacktrace. Previous actions of crashed
+	 *                      parties remain standing and valid.
 	 * @param progress      the {@link Progress} line. can be null if not yet
-	 *                      known. This happens because during setup we first
-	 *                      add all connections, and only when we have that we
-	 *                      set the correct deadline.
+	 *                      known. null happens because during initialization
+	 *                      phase the protocol first add all connections. During
+	 *                      this time, parties may already enter the
+	 *                      failed/exception state.
 	 * @param settings      the {@link SAOPSettings}
 	 * @param partyprofiles map with the {@link PartyWithProfile} for connected
 	 *                      parties. null is equivalent to an empty map.
-	 * @param evaluator     the {@link VotingEvaluator}
 	 */
 	@JsonCreator
 	protected MOPACState(@JsonProperty("phase") Phase phase,
 			@JsonProperty("actions") List<Action> actions,
-			@JsonProperty("connections") ProtocolToPartyConnections conns,
 			@JsonProperty("progress") Progress progress,
 			@JsonProperty("settings") MOPACSettings settings,
@@ -83,5 +91,4 @@
 		this.phase = phase;
 		this.actions = actions;
-		this.connections = conns;
 		this.progress = progress;
 		this.settings = settings;
@@ -90,101 +97,101 @@
 
 	/**
-	 * Can be called after all connections are initialized.
-	 * 
-	 * @param now current time ms since 1970
-	 * 
-	 * @return state with the initial partystates set.
-	 */
-	public MOPACState initPhase(long now) {
-		PartyStates partyStates = new PartyStates(getPowers());
-		Phase firstPhase = new OfferPhase(null, partyStates,
-				now + getAvailablePhaseTime(now),
-				settings.getVotingEvaluation());
-		return new MOPACState(firstPhase, actions, connections, progress,
-				settings, partyprofiles);
-	}
-
-	@Override
-	public List<Action> getActions() {
-		return Collections.unmodifiableList(actions);
-	}
-
-	@Override
-	public Progress getProgress() {
-		return progress;
-	}
-
-	public Map<PartyId, PartyWithProfile> getPartyProfiles() {
-		return Collections.unmodifiableMap(partyprofiles);
-	}
-
-	/**
-	 * @return all current/remaining active party connections. Finished/crashed
-	 *         parties should be removed immediately.
-	 */
-	public ProtocolToPartyConnections getConnections() {
-		return connections;
-	}
-
-	/**
-	 * @param now current time ms since 1970
-	 * @return the max possible duration in ms of the NEXT phase. Maybe 0 or
-	 *         negative if past deadline.
-	 */
-	private Long getAvailablePhaseTime(long now) {
-		// explicit check, to check also the round counts.
-		if (incrementProgress().isPastDeadline(now + Phase.PHASE_MINTIME))
-			return 0l;
-		return Math.min(progress.getTerminationTime().getTime() - now,
-				Phase.PHASE_MAXTIME);
-	}
-
-	/**
-	 * 
-	 * @param connection   the new {@link ProtocolToPartyConn}
-	 * @param partyprofile the {@link PartyWithProfile} that is associated with
-	 *                     this state
-	 * @return new {@link MOPACState} with the new connection added. This call
-	 *         ignores the progress (does not check isFinal) because we uses
-	 *         this during the setup where the deadline is not yet relevant.
-	 */
-	protected MOPACState with(ProtocolToPartyConn connection,
-			PartyWithProfile partyprofile) {
-		if (phase != null)
-			throw new IllegalStateException(
-					"Adding connections only allowed while initializing");
-
-		ProtocolToPartyConnections newconns = getConnections().with(connection);
-		Map<PartyId, PartyWithProfile> newprofiles = new HashMap<>(
-				partyprofiles);
-		newprofiles.put(connection.getParty(), partyprofile);
-		return new MOPACState(null, actions, newconns, progress, settings,
-				newprofiles);
-	}
-
-	/**
-	 * @param id the {@link PartyId} of the party that failed.
-	 * @param e  the {@link ProtocolException} that occurred in the party
-	 * @return a new state with the error set.
-	 */
-	public MOPACState with(ProtocolException e) {
-		return new MOPACState(phase.with(e), actions, connections, progress,
-				settings, partyprofiles);
-	}
-
-	/**
-	 * Sets the progress for this session. Can be set only if progress=null.
-	 * Should be set in INIT phase.
-	 * 
-	 * @param newprogress the new progress
-	 * @return new {@link MOPACState} with the progress set
-	 */
-	public MOPACState with(Progress newprogress) {
+	 * Sets the progress for this session and initial phase. Must be called
+	 * after all parties have been connected with
+	 * {@link #with(PartyId, PartyWithProfile)}.
+	 * 
+	 * @param newprogress the initial {@link Progress} typically matching the
+	 *                    settings deadline object
+	 * @param now         current time ms since 1970
+	 * 
+	 * @return state with the initial partystates , progress set.
+	 */
+	public MOPACState initPhase(Progress newprogress, long now) {
 		if (progress != null || newprogress == null || phase != null) {
 			throw new IllegalArgumentException(
 					"progress must be null, newprogress must be not null and phase must be INIT");
 		}
-		return new MOPACState(phase, actions, connections, newprogress,
-				getSettings(), partyprofiles);
+
+		PartyStates partyStates = new PartyStates(getPowers());
+		Phase firstPhase = new OfferPhase(partyStates,
+				now + getAvailablePhaseTime(newprogress, now),
+				settings.getVotingEvaluation());
+		return new MOPACState(firstPhase, actions, newprogress, settings,
+				partyprofiles);
+	}
+
+	@Override
+	public List<Action> getActions() {
+		return Collections.unmodifiableList(actions);
+	}
+
+	@Override
+	public Progress getProgress() {
+		return progress;
+	}
+
+	@Override
+	public Agreements getAgreements() {
+		return phase.getPartyStates().getAgreements();
+	}
+
+	@Override
+	public MOPACSettings getSettings() {
+		return settings;
+	}
+
+	public Map<PartyId, PartyWithProfile> getPartyProfiles() {
+		return Collections.unmodifiableMap(partyprofiles);
+	}
+
+	@Override
+	public boolean isFinal(long now) {
+		return phase != null && phase.isFinal(now) && !isNewPhasePossible(now);
+	}
+
+	@Override
+	public SessionResult getResult() {
+		return new SessionResult(partyprofiles, getAgreements(),
+				Collections.emptyMap(), null);
+	}
+
+	/**
+	 * @param progress the Progress that needs to be checked
+	 * @param now      current time ms since 1970
+	 * @return the max possible duration in ms of a phase considering the
+	 *         progress.
+	 */
+	private static Long getAvailablePhaseTime(Progress aprogress, long now) {
+		return Math.min(aprogress.getTerminationTime().getTime() - now,
+				Phase.PHASE_MAXTIME);
+	}
+
+	/**
+	 * @param id           the new {@link PartyId}
+	 * @param partyprofile the {@link PartyWithProfile} that is associated with
+	 *                     this state
+	 * @return new {@link MOPACState} with the new party added. This call
+	 *         ignores the progress (does not check isFinal) because we uses
+	 *         this during the setup where the deadline is not yet relevant.
+	 */
+	protected MOPACState with(PartyId id, PartyWithProfile partyprofile) {
+		if (phase != null)
+			throw new IllegalStateException(
+					"Adding connections only allowed while initializing");
+
+		Map<PartyId, PartyWithProfile> newprofiles = new HashMap<>(
+				partyprofiles);
+		newprofiles.put(id, partyprofile);
+		return new MOPACState(null, actions, progress, settings, newprofiles);
+	}
+
+	/**
+	 * @param e the {@link ProtocolException} that occured
+	 * @return a new state with the error set. You MUST have called
+	 *         {@link #initPhase(Progress, long)} before using this
+	 */
+	public MOPACState with(ProtocolException e) {
+		return new MOPACState(phase.with(e), actions, progress, settings,
+				partyprofiles);
 	}
 
@@ -202,22 +209,6 @@
 				Math.min(remainingNegoTime, Phase.PHASE_MAXTIME));
 
-		return new MOPACState(newphase, actions, connections,
-				incrementProgress(), getSettings(), partyprofiles);
-	}
-
-	/**
-	 * 
-	 * @return the next progress. Progress round advances if phase is
-	 *         {@link OptIn}.
-	 */
-	private Progress incrementProgress() {
-		if (progress instanceof ProgressRounds && phase instanceof OptInPhase)
-			return ((ProgressRounds) progress).advance();
-		return progress;
-	}
-
-	@Override
-	public boolean isFinal(long now) {
-		return phase != null && phase.isFinal(now) && !isNewPhasePossible(now);
+		return new MOPACState(newphase, actions, increment(progress, phase),
+				getSettings(), partyprofiles);
 	}
 
@@ -225,23 +216,17 @@
 	 * When this is called, all parties should have acted.
 	 * 
-	 * @param now
-	 * @return
+	 * @param now current time
+	 * @return true if there are still &gt;2 parties active and we have enough
+	 *         time for a new phase.
 	 */
 	public boolean isNewPhasePossible(long now) {
 		// System.out.println("phase=" + phase);
-		boolean a = phase.getPartyStates().getNegotiatingParties().size() >= 2
-				&& getAvailablePhaseTime(now) > Phase.PHASE_MINTIME;
-		// System.out.println("newstate possible:" + a);
-		return a;
-	}
-
-	@Override
-	public Agreements getAgreements() {
-		return phase.getPartyStates().getAgreements();
-	}
-
-	@Override
-	public MOPACSettings getSettings() {
-		return settings;
+		Progress newprogress = increment(progress, phase);
+		if (newprogress.isPastDeadline(now + Phase.PHASE_MINTIME))
+			return false;
+
+		return phase.getPartyStates().getNegotiatingParties().size() >= 2
+				&& getAvailablePhaseTime(newprogress,
+						now) > Phase.PHASE_MINTIME;
 	}
 
@@ -261,15 +246,24 @@
 	 * @param now    the current time in ms since 1970, see
 	 *               {@link System#currentTimeMillis()}
+	 * @return new {@link MOPACState} with the action checked and registered. If
+	 *         the action is not allowed, the new state may be that the actor is
+	 *         in the exception list.
 	 */
 
 	public MOPACState with(PartyId actor, Action action, long now) {
-		return new MOPACState(phase.with(actor, action, now), actions,
-				connections, progress, settings, partyprofiles);
-	}
-
-	@Override
-	public SessionResult getResult() {
-		return new SessionResult(partyprofiles, getAgreements(),
-				Collections.emptyMap(), null);
+		return new MOPACState(phase.with(actor, action, now), actions, progress,
+				settings, partyprofiles);
+	}
+
+	/**
+	 * @param aprogress the progress that might need to be advanced
+	 * @param aphase    the phase
+	 * @return the next progress. Progress round advances if phase is
+	 *         {@link OptIn}.
+	 */
+	private static Progress increment(Progress aprogress, Phase aphase) {
+		if (aprogress instanceof ProgressRounds && aphase instanceof OptInPhase)
+			return ((ProgressRounds) aprogress).advance();
+		return aprogress;
 	}
 
@@ -294,5 +288,5 @@
 	public String toString() {
 		return "MOPACState[" + phase + "," + settings + "," + partyprofiles
-				+ "," + connections + "," + progress + "," + "]";
+				+ "," + progress + "]";
 	}
 
@@ -306,6 +300,58 @@
 		LinkedList<Action> newactions = new LinkedList<Action>(actions);
 		newactions.addAll(newphase.getPartyStates().getActions());
-		return new MOPACState(newphase, newactions, connections, progress,
-				settings, partyprofiles);
+		return new MOPACState(newphase, newactions, progress, settings,
+				partyprofiles);
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((actions == null) ? 0 : actions.hashCode());
+		result = prime * result
+				+ ((partyprofiles == null) ? 0 : partyprofiles.hashCode());
+		result = prime * result + ((phase == null) ? 0 : phase.hashCode());
+		result = prime * result
+				+ ((progress == null) ? 0 : progress.hashCode());
+		result = prime * result
+				+ ((settings == null) ? 0 : settings.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		MOPACState other = (MOPACState) obj;
+		if (actions == null) {
+			if (other.actions != null)
+				return false;
+		} else if (!actions.equals(other.actions))
+			return false;
+		if (partyprofiles == null) {
+			if (other.partyprofiles != null)
+				return false;
+		} else if (!partyprofiles.equals(other.partyprofiles))
+			return false;
+		if (phase == null) {
+			if (other.phase != null)
+				return false;
+		} else if (!phase.equals(other.phase))
+			return false;
+		if (progress == null) {
+			if (other.progress != null)
+				return false;
+		} else if (!progress.equals(other.progress))
+			return false;
+		if (settings == null) {
+			if (other.settings != null)
+				return false;
+		} else if (!settings.equals(other.settings))
+			return false;
+		return true;
 	}
 
Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/PartyStates.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/PartyStates.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/PartyStates.java	(revision 24)
@@ -1,6 +1,4 @@
 package geniusweb.protocol.session.mopac;
 
-import java.util.Arrays;
-import java.util.Collection;
 import java.util.Collections;
 import java.util.HashMap;
@@ -12,4 +10,9 @@
 import java.util.stream.Collectors;
 
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
 import geniusweb.actions.Action;
 import geniusweb.actions.EndNegotiation;
@@ -19,6 +22,6 @@
 
 /**
- * The current state of all participating parties. A party either notYetActed,
- * did action, reached an agreement, walked away or made a
+ * Invariant: contains the current state of all participating parties. A party
+ * either notYetActed, did action, reached an agreement, walked away or made a
  * {@link ProtocolException}.
  * <p>
@@ -26,6 +29,6 @@
  * agreements and move remaining parties back to notYetActed.
  * 
- * This is not considering current time or checking actions.
  */
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
 public class PartyStates {
 	// all parties must be in exactly one state at all times.
@@ -35,5 +38,20 @@
 	private final List<PartyId> walkedAway;
 	private final Map<PartyId, ProtocolException> exceptions;
-	private Map<PartyId, Integer> powers;
+	private final Map<PartyId, Integer> powers;
+
+	@JsonCreator
+	protected PartyStates(@JsonProperty("notYetActed") Set<PartyId> notYetActed,
+			@JsonProperty("actions") List<Action> actions,
+			@JsonProperty("agreements") Agreements agreements,
+			@JsonProperty("walkedAway") List<PartyId> walkedAway,
+			@JsonProperty("exceptions") Map<PartyId, ProtocolException> exceptions,
+			@JsonProperty("powers") Map<PartyId, Integer> powers) {
+		this.notYetActed = notYetActed;
+		this.actions = actions;
+		this.agreements = agreements;
+		this.walkedAway = walkedAway;
+		this.exceptions = exceptions;
+		this.powers = powers;
+	}
 
 	/**
@@ -51,20 +69,12 @@
 	}
 
-	public PartyStates(Set<PartyId> notYetActed, List<Action> actions,
-			Agreements agreements, List<PartyId> walkedAway,
-			Map<PartyId, ProtocolException> exceptions,
-			Map<PartyId, Integer> powers) {
-		this.notYetActed = notYetActed;
-		this.actions = actions;
-		this.agreements = agreements;
-		this.walkedAway = walkedAway;
-		this.exceptions = exceptions;
-		this.powers = powers;
-	}
-
-	/**
-	 * 
-	 * @param action
-	 * @return new state with party done given action.
+	/**
+	 * 
+	 * @param action the action done by some party. The correctness of action,
+	 *               particularly of {@link Action#getActor()}, must be correct.
+	 * @return new state with party done given action. This just accepts any
+	 *         given action and is not considering number of rounds, time or
+	 *         whether an action is allowed.
+	 * 
 	 * @throws IllegalArgumentException if party doing action already acted.
 	 *                                  This is just a safety check as legality
@@ -151,10 +161,16 @@
 
 	/**
-	 * 
 	 * @param actor
 	 * @return {@link #notYetActed} with actor removed
-	 */
-	private Set<PartyId> removeParty(PartyId actor) {
-		return removeParties(new HashSet<>(Arrays.asList(actor)));
+	 * @throws IllegalArgumentException if party already acted (not in
+	 *                                  {@link #notYetActed}).
+	 */
+	private Set<PartyId> removeParty(PartyId party) {
+		Set<PartyId> newActiveParties = new HashSet<>(notYetActed);
+		if (!newActiveParties.remove(party))
+			throw new IllegalArgumentException(
+					"Party " + party + " is not active, can't be removed");
+		return newActiveParties;
+
 	}
 
@@ -169,19 +185,4 @@
 	public Map<PartyId, ProtocolException> getExceptions() {
 		return Collections.unmodifiableMap(exceptions);
-	}
-
-	/**
-	 * 
-	 * @param parties the parties to remove
-	 * @return {@link #notYetActed} without the given parties.
-	 */
-	private Set<PartyId> removeParties(Collection<PartyId> parties) {
-		Set<PartyId> newActiveParties = new HashSet<>(notYetActed);
-		for (PartyId party : parties) {
-			if (!newActiveParties.remove(party))
-				throw new IllegalArgumentException(
-						"Party " + party + " is not active, can't be removed");
-		}
-		return newActiveParties;
 	}
 
@@ -204,5 +205,16 @@
 
 	/**
-	 * @param type the type of actions to extract
+	 * 
+	 * @return all parties that walked away
+	 */
+	public List<PartyId> getWalkedAway() {
+		return walkedAway;
+	}
+
+	/**
+	 * @param <T>  the type of objects requested
+	 * @param type the type of actions to extract. Must be of type T, needed
+	 *             because of java's type erasure.
+	 * 
 	 * @return all actions of type done in this phase
 	 */
@@ -233,3 +245,62 @@
 	}
 
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((actions == null) ? 0 : actions.hashCode());
+		result = prime * result
+				+ ((agreements == null) ? 0 : agreements.hashCode());
+		result = prime * result
+				+ ((exceptions == null) ? 0 : exceptions.hashCode());
+		result = prime * result
+				+ ((notYetActed == null) ? 0 : notYetActed.hashCode());
+		result = prime * result + ((powers == null) ? 0 : powers.hashCode());
+		result = prime * result
+				+ ((walkedAway == null) ? 0 : walkedAway.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		PartyStates other = (PartyStates) obj;
+		if (actions == null) {
+			if (other.actions != null)
+				return false;
+		} else if (!actions.equals(other.actions))
+			return false;
+		if (agreements == null) {
+			if (other.agreements != null)
+				return false;
+		} else if (!agreements.equals(other.agreements))
+			return false;
+		if (exceptions == null) {
+			if (other.exceptions != null)
+				return false;
+		} else if (!exceptions.equals(other.exceptions))
+			return false;
+		if (notYetActed == null) {
+			if (other.notYetActed != null)
+				return false;
+		} else if (!notYetActed.equals(other.notYetActed))
+			return false;
+		if (powers == null) {
+			if (other.powers != null)
+				return false;
+		} else if (!powers.equals(other.powers))
+			return false;
+		if (walkedAway == null) {
+			if (other.walkedAway != null)
+				return false;
+		} else if (!walkedAway.equals(other.walkedAway))
+			return false;
+		return true;
+	}
+
 }
Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/DefaultPhase.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/DefaultPhase.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/DefaultPhase.java	(revision 24)
@@ -1,12 +1,6 @@
 package geniusweb.protocol.session.mopac.phase;
-
-import java.util.List;
-import java.util.stream.Collectors;
-
-import com.fasterxml.jackson.annotation.JsonIgnore;
 
 import geniusweb.actions.Action;
 import geniusweb.actions.PartyId;
-import geniusweb.actions.Votes;
 import geniusweb.protocol.ProtocolException;
 import geniusweb.protocol.session.mopac.PartyStates;
@@ -17,26 +11,15 @@
 	protected final Long deadline;
 	protected final PartyStates partyStates;
-
-	// don't serialize this, users don't need it..
-	@JsonIgnore
 	protected final VotingEvaluator evaluator;
 
-	// don't serialize this, it will cause very large file
-	@JsonIgnore
-	protected final Phase prevPhase;
-
 	/**
-	 * 
-	 * @param actions     the actions done in this phase .
-	 * @param prevPhase   the previous phase, can be used to collect previous
-	 *                    votes etc.
-	 * @param partyStates
+	 * @param partyStates the {@link PartyStates}
 	 * @param deadline    deadline for this phase, ms since 1970
+	 * @param evaluator   the {@link VotingEvaluator} to be used
 	 */
-	public DefaultPhase(Phase prevPhase, PartyStates partyStates, Long deadline,
+	public DefaultPhase(PartyStates partyStates, Long deadline,
 			VotingEvaluator evaluator) {
 		this.partyStates = partyStates;
 		this.deadline = deadline;
-		this.prevPhase = prevPhase;
 		this.evaluator = evaluator;
 	}
@@ -53,13 +36,4 @@
 
 	/**
-	 * @return all votes done in this phase.
-	 */
-	public List<Votes> getVotes() {
-		return partyStates.getActions().stream()
-				.filter(act -> act instanceof Votes).map(act -> (Votes) act)
-				.collect(Collectors.toList());
-	}
-
-	/**
 	 * Check if actor can do given action. Basic checks:
 	 * <ul>
@@ -70,13 +44,10 @@
 	 * </ul>
 	 * 
-	 * @param activeParties the currently active parties
-	 * @param actor
-	 * @param action
-	 * @param timems
-	 * @throws ProtocolException
-	 * @throw ProtocolException if the action violates the protocol, or null if
-	 *        ok
+	 * @param actor  the actor that really acted
+	 * @param action the action that was done
+	 * @param now    current time
+	 * @throws ProtocolException if the action violates the protocol
 	 */
-	protected void checkAction(PartyId actor, Action action, long timems)
+	protected void checkAction(PartyId actor, Action action, long now)
 			throws ProtocolException {
 		if (action == null)
@@ -86,10 +57,9 @@
 					"Incorrect actor info in action:" + action.getActor(),
 					actor);
-		if (isFinal(timems))
+		if (isFinal(now))
 			throw new ProtocolException("passed deadline", actor);
 		if (!(getAllowedActions().contains(action.getClass())))
-			throw new ProtocolException(
-					"Action not allowed in " + this.getClass() + ":" + action,
-					actor);
+			throw new ProtocolException("Action not allowed in "
+					+ this.getClass().getSimpleName() + ": " + action, actor);
 		if (!partyStates.getNotYetActed().contains(actor))
 			throw new ProtocolException("Actor can not act anymore", actor);
@@ -98,5 +68,4 @@
 
 	/**
-	 * @param timems current time
 	 * @return current PartyStates
 	 */
@@ -116,24 +85,61 @@
 			throw new IllegalArgumentException("Bug, illegal duration");
 		if (!isFinal(now))
-			throw new IllegalStateException(
-					"next must only be called when phase isFinal");
-		if (!partyStates.getNotYetActed().isEmpty())
-			throw new IllegalStateException("Bug. State has not been finished");
+			throw new IllegalStateException("phase is not final");
 		return checkedNext(now + duration);
 	}
 
 	/**
+	 * As {@link #next(long, long)} but DefaultPhase already checked that 1.
+	 * there is enough time for a next phase 2. current state is final 3.
 	 * 
-	 * @param deadline
+	 * @param dl the deadline for the next phase (ms since 1970).
 	 * @return the next phase
 	 */
-	protected abstract Phase checkedNext(long deadline);
+	protected abstract Phase checkedNext(long dl);
 
 	@Override
 	public String toString() {
-		// don't print prev state, it will give HUGE list because it also
-		// contains prevstate.....
 		return getClass().getSimpleName() + "[" + partyStates + "," + deadline
 				+ "," + evaluator + "]";
 	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((deadline == null) ? 0 : deadline.hashCode());
+		result = prime * result
+				+ ((evaluator == null) ? 0 : evaluator.hashCode());
+		result = prime * result
+				+ ((partyStates == null) ? 0 : partyStates.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		DefaultPhase other = (DefaultPhase) obj;
+		if (deadline == null) {
+			if (other.deadline != null)
+				return false;
+		} else if (!deadline.equals(other.deadline))
+			return false;
+		if (evaluator == null) {
+			if (other.evaluator != null)
+				return false;
+		} else if (!evaluator.equals(other.evaluator))
+			return false;
+		if (partyStates == null) {
+			if (other.partyStates != null)
+				return false;
+		} else if (!partyStates.equals(other.partyStates))
+			return false;
+		return true;
+	}
 }
Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/OfferPhase.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/OfferPhase.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/OfferPhase.java	(revision 24)
@@ -4,4 +4,7 @@
 import java.util.List;
 import java.util.stream.Collectors;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
 
 import geniusweb.actions.Action;
@@ -18,7 +21,9 @@
 public class OfferPhase extends DefaultPhase {
 
-	public OfferPhase(Phase prevPhase, PartyStates partyStates, Long deadlinems,
-			VotingEvaluator evaluator) {
-		super(prevPhase, partyStates, deadlinems, evaluator);
+	@JsonCreator
+	public OfferPhase(@JsonProperty("partyStates") PartyStates partyStates,
+			@JsonProperty("deadlinems") Long deadlinems,
+			@JsonProperty("evaluator") VotingEvaluator evaluator) {
+		super(partyStates, deadlinems, evaluator);
 	}
 
@@ -30,6 +35,5 @@
 			return this.with(ex);
 		}
-		return new OfferPhase(prevPhase, partyStates.with(action), deadline,
-				evaluator);
+		return new OfferPhase(partyStates.with(action), deadline, evaluator);
 	}
 
@@ -42,20 +46,19 @@
 	public OfferPhase with(ProtocolException e) {
 		System.out.println("Party kicked because of protocol exception:" + e);
-		return new OfferPhase(prevPhase, partyStates.with(e), deadline,
-				evaluator);
+		return new OfferPhase(partyStates.with(e), deadline, evaluator);
 	}
 
 	@Override
 	public Phase finish() {
-		return new OfferPhase(prevPhase, partyStates.finish(), deadline,
-				evaluator);
+		return new OfferPhase(partyStates.finish(), deadline, evaluator);
 	}
 
 	@Override
 	public VotingPhase checkedNext(long deadln) {
-		return new VotingPhase(this, partyStates.flush(), deadln, evaluator);
+		return new VotingPhase(getOffers(), partyStates.flush(), deadln,
+				evaluator);
 	}
 
-	public List<Bid> getOffers() {
+	protected List<Bid> getOffers() {
 		return partyStates.getActions(Offer.class).stream()
 				.map(offer -> offer.getBid()).collect(Collectors.toList());
